<div class="container-fluid p-py-5 projects-override">
  <p-table #dt [scrollable]="true" scrollHeight="500px" [value]="projects" (sortFunction)="customSort($event)"
    [customSort]="true" [globalFilterFields]="['name', 'category.name', 'account.name']"
    styleClass="p-datatable-striped">
    <ng-template pTemplate="caption">
      <div class="d-flex justify-content-between align-items-center">
        <div class="d-flex align-items-center flex-grow-1">
          <p-checkbox value="Show closed" inputId="sc" [(ngModel)]="showClosedProjects" [binary]="true"
            (onChange)="dt.filter(this.showClosedProjects ? '' : 'false','isClosed','equals');"></p-checkbox>
            <label for="sc" class="mt-2 ml-1">Show closed</label>
        </div>
        <div class="flex-grow-2 text-center">
          <input type="text" pInputText size="50" placeholder="Search"
            (input)="dt.filterGlobal(getEventValue($event), 'contains')" class="w-auto" />
        </div>
        <div class="flex-grow-1"></div>
      </div>
    </ng-template>
    <ng-template pTemplate="header">
      <tr>
        <th pSortableColumn="name" style="width: 17%;" (dblclick)="resetSort()">Name
          <span *ngIf="currentSort!='none'">
            <p-sortIcon field="name"></p-sortIcon>
          </span>
        </th>
        <th style="width: 17%;">Category</th>
        <th style="width: 17%;">Account</th>
        <th style="width: 16%;">Internal hours</th>
        <th style="width: 16%;">External hours</th>
        <th style="width: 16%;">Reporting Closing</th>
        <th *ngIf="hasWritePermission">
          <button pButton icon="fa fa-plus" (click)="onAddProject()"></button>
        </th>
      </tr>
    </ng-template>
    <ng-template pTemplate="body" let-project>
      <tr>
        <td>{{ project.name }}</td>
        <td>{{ project.category?.name }}</td>
        <td>{{ project.account.name }}</td>
        <td *ngIf="project.overrideHoursSettings; else inherited">
          {{ project.minInternal }} - {{ project.maxInternal }}
        </td>
        <td *ngIf="project.overrideHoursSettings; else inherited">
          {{ project.minExternal }} - {{ project.maxExternal }}
        </td>
        <td *ngIf="project.overrideClosingSettings; else inherited">
          <span *ngIf="supportsClosingType(project.closingType); else mondayType">
            {{ project.closingType }} [{{ project.beforeClosing }}; {{ project.afterClosing }}]
          </span>
          <ng-template #mondayType>
            {{ project.closingType }}
          </ng-template>
        </td>
        <ng-template #inherited>
          <td>Inherited</td>
        </ng-template>
        <td *ngIf="hasWritePermission">
          <div class="d-flex justify-content-between">
            <button pButton icon="fa fa-pencil" (click)="onEditProject(project)"></button>
          </div>
        </td>
      </tr>
    </ng-template>
  </p-table>

  <p-dialog 
  [(visible)]="dialogVisible" 
  [responsive]="true" 
  [resizable]="false" 
  showEffect="fade" 
  [modal]="true"
  [style]="{ width: '690px' }">
    <form [formGroup]="form" (ngSubmit)="onSaveProject()">
      <div class="form-group form-row" style="margin-top: 1.5rem">
        <div class="col-md-2 col-form-label text-md-right">Name</div>
        <div class="col-md">
          <input formControlName="name" id="name" pInputText [(ngModel)]="editProject.name" type="text"
            class="w-100" />
          <div *ngIf="f['name'].touched && f['name'].invalid" class="text-danger">
            <div *ngIf="f['name'].errors && f['name'].errors['required']">Name is required.</div>
            <div *ngIf="f['name'].errors && f['name'].errors['maxlength']">Name must be less than 100 characters long</div>
            <div *ngIf="f['name'].errors && f['name'].errors['canNotContainWhiteSpaces']">Name can not contain whitespaces</div>
          </div>
        </div>
      </div>

      <div class="form-group form-row">
        <div class="col-md-2 col-form-label text-md-right">Category</div>
        <div class="col-md">
          <app-filter-dropdown
            [(selectedItem)]="editProject.category"
            [options]="categories"
            [style]="{ width: '100%' }"
            [selectedItemConfigOptions]="{standalone: true}"
          ></app-filter-dropdown>
        </div>
      </div>

      <div class="form-group form-row">
        <div class="col-md-2 col-form-label text-md-right">Account</div>
        <div class="col-md">
          <app-filter-dropdown
            [(selectedItem)]="editProject.account"
            [options]="accounts"
            [style]="{ width: '100%' }"
            [selectedItemConfigOptions]="{standalone: true}"
          ></app-filter-dropdown>
        </div>
      </div>

      <div class="form-group form-row">
        <div class="col-md-2 col-form-label text-md-right">Start Date</div>
        <div class="col-md-4">
        <p-calendar formControlName="startDate"
                    [readonlyInput]="true"
                    [showIcon]="true"
                    [monthNavigator]="true"
                    [yearNavigator]="true"
                    [appendTo]="'body'"
                    [baseZIndex]="10000"
                    [showClear]="true"
                    [showButtonBar]="true"
                    [minDate]="minDate"
                    [readonlyInput]="true"
                    class="m-1">
        </p-calendar> 
        <div class="text-danger" *ngIf="form.get('startDate').errors?.invalidDateFormat">Please enter a complete, valid date (MM/DD/YYYY)</div>
      </div>
      <div class="col-md-2 col-form-label text-md-right">End Date</div>
        <div class="col-md-4">
          <p-calendar formControlName="endDate"
          [readonlyInput]="true"
          [showIcon]="true"
          [monthNavigator]="true"
          [yearNavigator]="true"
          [appendTo]="'body'"
          [baseZIndex]="10000"
          [showClear]="true"
          [showButtonBar]="true"
          [minDate]="minDate"
          class="m-1">
          </p-calendar>
          <div class="text-danger" *ngIf="form.get('endDate').errors?.invalidDateFormat">Please enter a complete, valid date (MM/DD/YYYY)</div>
        </div>
      </div>

      <div class="text-danger text-center" *ngIf="form.errors?.dateRange">Start date must be before end date</div>

      <div class="form-group form-row" style="margin-bottom: 0.5rem;">
        <div class="offset-md-2 col-6">
          <p-checkbox [(ngModel)]="editProject.autoAssignNewUsers" [binary]="true" label="Auto assign new users"
            [ngModelOptions]="{standalone: true}"></p-checkbox>
        </div>
        <div class="col-4">
          <p-checkbox [(ngModel)]="editProject.isClosed" [binary]="true" label="Closed"
            [ngModelOptions]="{standalone: true}"></p-checkbox>
        </div>
      </div>

      <div class="form-group form-row">
        <div class="col-12">
          <p-fieldset>
            <p-header>
              <p-checkbox [(ngModel)]="editProject.overrideHoursSettings" [binary]="true"
                label="Override reporting hours settings" [ngModelOptions]="{standalone: true}"></p-checkbox>
            </p-header>
              <div class="form-group form-row">
                <div class="col-3 text-right col-form-label">Internal</div>
                <div class="col-6">
                  <div style="padding: 0 8px">
                    <div style="margin-bottom: 5px; margin-top: -10px">
                      {{
                      editProject.minInternal + " - " + editProject.maxInternal
                      }}
                    </div>
                    <p-slider #internalSlider [ngModel]="[
                          editProject.minInternal * 2,
                          editProject.maxInternal * 2
                        ]" (ngModelChange)="onInternalHoursChange($event)" [range]="true" [min]="0" [max]="24" [step]="1"
                      [disabled]="!editProject.overrideHoursSettings" [style]="{ width: '100%' }"
                      [ngModelOptions]="{standalone: true}"></p-slider>
                  </div>
                </div>
              </div>
              <div class="form-group form-row">
                <div class="col-3 text-right col-form-label">External</div>
                <div class="col-6">
                  <div style="padding: 0 8px">
                    <div style="margin-bottom: 5px; margin-top: -10px">
                      {{
                      editProject.minExternal + " - " + editProject.maxExternal
                      }}
                    </div>
                    <p-slider #externalSlider [ngModel]="[
                          editProject.minExternal * 2,
                          editProject.maxExternal * 2
                        ]" (ngModelChange)="onExternalHoursChange($event)" [range]="true" [min]="0" [max]="24" [step]="1"
                      [disabled]="!editProject.overrideHoursSettings" [style]="{ width: '100%' }"
                      [ngModelOptions]="{standalone: true}"></p-slider>
                  </div>
                </div>
              </div>
          </p-fieldset>
        </div>
      </div>

      <div class="form-group form-row">
        <div class="col-12">
          <p-fieldset>
            <p-header>
              <p-checkbox [(ngModel)]="editProject.overrideClosingSettings" [binary]="true"
                label="Override reporting closing settings" [ngModelOptions]="{standalone: true}"></p-checkbox>
            </p-header>
              <div class="form-group form-row">
                <div class="col-3 text-right col-form-label align-self-center">Closing type</div>
                <div class="col-6">
                  <p-dropdown [(ngModel)]="editProject.closingType" [options]="closingTypes"
                    [disabled]="!editProject.overrideClosingSettings" [style]="{ width: '100%' }"
                    [ngModelOptions]="{standalone: true}"></p-dropdown>
                </div>
              </div>
              <div class="form-group form-row" *ngIf="supportsClosingType(editProject.closingType)">
                <div class="col-3 text-right col-form-label align-self-center">Window before</div>
                <div class="col-2">
                    <p-inputNumber
                      [(ngModel)]="editProject.beforeClosing"
                      [disabled]="!editProject.overrideClosingSettings"
                      [ngModelOptions]="{standalone: true}"
                      [useGrouping]="false"
                    ></p-inputNumber>
                </div>
                <div class="col-2 text-right col-form-label align-self-center">after</div>
                <div class="col-2">
                    <p-inputNumber
                      [(ngModel)]="editProject.afterClosing"
                      [disabled]="!editProject.overrideClosingSettings"
                      [ngModelOptions]="{standalone: true}"
                      [useGrouping]="false"
                    ></p-inputNumber>
                </div>
                <div class="col-2 text-right col-form-label align-self-center">(days)</div>
              </div>
              <div class="p-px-5 mb-2">
                <i class="fa fa-info-circle"></i>
                <span>
                  Overriding reporting settings is temporary and restores in 1 hour
                </span>
              </div>
              <div *ngIf="projectConfigurationBackup" class="p-px-5 mb-2">
                <i class="fa fa-warning"></i>
                <span>
                  Original reporting closing settings will be restored on
                  {{ projectConfugurationBackupExpiration | date: 'MM/dd/yyyy HH:mm'}}
                </span>
              </div>
              <div *ngIf="editProject.projectReopenRequests?.length > 0" class="p-px-5 mb-2">
                <p-button
                  [link]="true"
                  title="Open list of active reopen requests"
                  (click)="reopenRequestsDialogVisible = !reopenRequestsDialogVisible"
                >
                  <i class="fa fa-warning"></i>
                  <span class="p-button-label">There are employees with active reporting requests.</span>
                </p-button>
              </div>
          </p-fieldset>
        </div>
      </div>

      <div class="form-group form-row">
        <div class="col-12">
          <p-fieldset>
            <p-header>
              <p-checkbox [(ngModel)]="overrideProjectType" [binary]="true" label="Override project type"
                [ngModelOptions]="{standalone: true}"></p-checkbox>
            </p-header>
            <div *ngIf="overrideProjectType">
              <div class="form-group form-row">
                <div class="col-3 text-right col-form-label align-self-center">Type</div>
                <div class="col-6">
                  <p-dropdown [(ngModel)]="editProject.projectType" [options]="projectTypes" [style]="{ width: '100%' }"
                  [ngModelOptions]="{standalone: true}" (onChange)="onProjectTypeChange($event.value)" (click)="$event.stopPropagation()"
                  appendTo="body"></p-dropdown>
                </div>
              </div>
              <div class="form-group form-row">
                <div class="offset-3 col-6 text-left py-0">
                  <ng-container [ngTemplateOutlet]="editProject.projectType === 0 ? first : editProject.projectType === 1 ? second : third"></ng-container>
                  <ng-template #first> <p>External projects are the projects associated with Leobit clients</p></ng-template>
                  <ng-template #second> <p>Projects related to various company internal activities</p></ng-template>
                  <ng-template #third><p class="text-warning">This project type is used by the system, don’t use it explicitly</p></ng-template>
                </div>
              </div>
              <div class="form-group form-row">
                <div class="col-3 text-right col-form-label align-self-center">Priority</div>
                <div class="col-6">
                  <p-dropdown [(ngModel)]="editProject.projectPriority" [options]="projectPriorities" [style]="{ width: '100%' }"
                    (click)="$event.stopPropagation()" appendTo="body" formControlName="projectPriority"></p-dropdown>
                </div>
              </div>
              <div class="form-group form-row">
                <div class="offset-3 col-6 text-left py-0">
                  <ng-container [ngSwitch]="editProject.projectPriority">
                    <div *ngSwitchCase="projectPriority.VeryLow">
                      <p>Used only for "Reserve" account, should not be set manually</p>
                    </div>
                    <div *ngSwitchCase="projectPriority.Low">
                      <p>Low-priority internal assignments. Reports to this project will be considered as Reserve reports</p>
                    </div>
                    <div *ngSwitchCase="projectPriority.Medium">
                      <p>High-priority internal assignments (such as HR, Finance, etc.). Reports to this project will NOT be considered Reserve reports</p>
                    </div>
                    <div *ngSwitchCase="projectPriority.High">
                      <p>External projects, vacations and sick-leaves</p>
                    </div>
                  </ng-container>
                </div>
              </div>
              <div *ngIf="editProject.id!= 0 && overrideProjectType" class="form-group form-row mt-2">
                <div class="offset-3 col-6 col-form-label">
                  <p-checkbox [(ngModel)]="editProject.overrideTimeReportPriorities" [binary]="true"
                    label="Apply priority to existing time reports" [ngModelOptions]="{standalone: true}"></p-checkbox>
                </div>
              </div>
            </div>
          </p-fieldset>
        </div>
      </div>

      <div class="form-group form-row">
        <div class="col-12 text-right">
          <button pButton label="Save" [disabled]="form.invalid" type="submit"></button>
        </div>
      </div>
    </form>
  </p-dialog>

  <p-dialog [(visible)]="reopenRequestsDialogVisible" [responsive]="true" [resizable]="false"
    [focusOnShow]="false" showEffect="fade" [modal]="true" [style]="{ 'width': '800px', minWidth: '400px', minHeight: '300px' }"
    [contentStyle]="{ 'max-height': 'calc(100vh - 200px)', 'overflow-y': 'auto' }" (onShow)="updateExpirationTimes()"
    header="Active project reporting reopen requests">
    <p-table [scrollable]="true" [value]="editProject.projectReopenRequests" [autoLayout]="true">
      <ng-template pTemplate="header">
        <tr>
          <th>Employee</th>
          <th>Date Range</th>
          <th>Status</th>
          <th>Approver</th>
        </tr>
      </ng-template>

      <ng-template pTemplate="body" let-reopenRequest>
        <tr>
          <td>{{reopenRequest.senderFullName}}</td>
          <td>{{reopenRequest.startDate | date: 'MM/dd/yyyy'}} - {{reopenRequest.endDate | date: 'MM/dd/yyyy'}}</td>
          <td>
            <span *ngIf="reopenRequest.projectManagerApprovedFullName; else notApproved">Approved;</span>
            <ng-template #notApproved>Pending;</ng-template>
            expires {{reopenRequest.expirationTime | timeToDate}}
          </td>
          <td>
            <span *ngIf="reopenRequest.projectManagerApprovedFullName; else noApprover">
              {{reopenRequest.projectManagerApprovedFullName}}
            </span>
            <ng-template #noApprover>
              <button pButton [disabled]="!reopenRequest.canApprove" (click)="approveReopenRequest(reopenRequest.id)" class="p-button mr-1">Approve</button>
              <button pButton [disabled]="!reopenRequest.canApprove" (click)="declineReopenRequest(reopenRequest.id)" class="p-button-danger">Decline</button>
            </ng-template>
          </td>
        </tr>
      </ng-template>
    </p-table>
  </p-dialog>
</div>
